.\" $Id: rrdup.man,v 1.8 2012/02/29 18:45:35 ksb Exp $
.\" by Kevin Braunsdorf
.\" $Compile: Display%h
.\" $Display: ${groff:-groff} -Tascii -man %f |${PAGER:-less}
.\" $Display(*): ${groff:-groff} -T%s -man %f
.\" $Install: %b -mDeinstall %o %f && cp %f $DESTDIR/usr/local/man/man1/rrdup.1
.\" $Deinstall: ${rm-rm} -f $DESTDIR/usr/local/man/[cm]a[nt]1/rrdup.1*
.TH RRDUP 1 LOCAL
.SH NAME
rrdup - update RRD files on a remote host
.SH SYNOPSIS
.ds PN "rrdup
\fI\*(PN\fP \fI[host:]port\fP
.br
\fI\*(PN\fP \fB\-h\fP
.br
\fI\*(PN\fP \fB\-V\fP

.SH DESCRIPTION
\fBRrdup\fP reads \fBrrdupdate\fP(1l) commands on \fBstdin\fP, encodes each
as a UDP datagram, send them to the \fIhost\fP on the specified
\fPport\fP where an instance of rrd's daemon is listening for updates.
.PP
This allows for a very cheap update of an RRD file.  The cost of a
UDP datagram is slight.

.P
The positional parameter \fI[host:]port\fP
specifies the destination for the RRD update.
.SH OPTIONS
If the program is called as \fI\*(PN\fP then no options are forced.
.TP
\fB\-h\fP
Print a help message.
.TP
\fB\-V\fP
Show version information.
.SH EXAMPLES
.TP
.nf
echo "update host/`uname \-n`/event.rrd \-t 1:344 N:evens:odds" |rrdup
.fi
Send an update for the "evens" and "odds" data sources in the file
"event.rrd" for this host.  This is naive as the hostname returned
by \fBuname\fP is not going to be correct for (the local instance of) PEG.

.SH BUGS
None known.

.SH AUTHOR
C. Stephen Gunn & Kevin Braunsdorf, NPC Guild
.br
peg no-pesky_lunch-meat ksb.npcguild.org

.SH "SEE ALSO"
.hlm 0
sh(1), rrdtool(1l), rrdupdate(1l), rrdd(8l)
